var com_medienarche_all_categories = [];
var com_medienarche_download_id;
var com_medienarche_selected_path = "";
var com_medienarche_variant;
var com_medienarche_skip_size_calc = false;

jQuery(document).ready(function() {
	
	if (com_medienarche_apikey != "") {
		jQuery("#com_medienarche_results").fadeIn(200);
		//Kategorien laden
		com_medienarche_api("categories",null, "com_medienarche_categories_cb");
	} else {
		jQuery("#com_medienarche_authentification").fadeIn(200);
		jQuery("#com_medienarche_loader").fadeOut(200);
	}
	
	//Events
	jQuery("#com_medienarche_authentification_submit").click(function(e){
		com_medienarche_api("auth",null, "com_medienarche_auth_cb");
	});
	
	
	jQuery("#com_medienarche_filter_text").on("change", function(e){
		com_medienarche_search();
	});
	jQuery("#com_medienarche_filter_category").on("change", function(e){
		com_medienarche_search();
	});	
	
});
 
//API Calls
function com_medienarche_api(task, params, callback) {
	var headers = {};
	var auth = "APIKEY " + com_medienarche_apikey;
	if (task == "auth") {
		auth = "Basic " + btoa(jQuery("#com_medienarche_username").val() +":" + jQuery("#com_medienarche_password").val());
	}
	jQuery("#com_medienarche_loader").stop();
	jQuery("#com_medienarche_loader").fadeIn(200);
	
	jQuery.ajax({
		dataType: 'json',
		url: "index.php?option=com_medienarche&api=1&path="+task,
		crossDomain: false,
		beforeSend: function (xhr) {
			xhr.setRequestHeader("X-Aki-Ma-Authorization", auth);
		},
		error: function(jqXHR, textStatus, errorThrown ) {
			alert ("Error during request: " + errorThrown);
		},
		success: function(data, textStatus, jqXHR) {
			if (data.error.code != 0) {
				alert("Fehler "+data.error.code+": " + data.error.description);
				return;
			}
			window[callback](data);
		},
		complete: function(jqXHR, textStatus ) {
			if (jQuery.active <= 1) {
				jQuery("#com_medienarche_loader").fadeOut(200);
			}
		}
	});
}

//Callback for Auth
function com_medienarche_auth_cb(data) {
	com_medienarche_apikey = data.content['API key'];
	com_medienarche_api("local_store_apikey&apikey="+data.content['API key'], null, "com_medienarche_storeapikey_cb");
}
function com_medienarche_storeapikey_cb(data) {
	if (data.content != "success") {
		alert("Der API-Key konnte nicht gespeichert werden");
		return false;
	}
	alert("Sie wurden erfolgreich angemeldet");
	
	jQuery("#com_medienarche_authentification").fadeOut(200);
	jQuery("#com_medienarche_results").fadeIn(200);
	com_medienarche_api("categories",null, "com_medienarche_categories_cb");
}

function com_medienarche_categories_cb(data) {
	jQuery("#com_medienarche_filter_category option[value!='']").remove();
	for (var i=0;i<data.content.length; i++) {
		jQuery("#com_medienarche_filter_category").append('<option value="'+data.content[i].id+'">'+data.content[i].name+'</option>');
		com_medienarche_all_categories.push(data.content[i].id);
	}
	jQuery('#com_medienarche_results').trigger('create');
	com_medienarche_search();
}
function com_medienarche_search_cb(data) {
	jQuery("#com_medienarche_result_list").show();
	jQuery("#com_medienarche_result_list").html("");
	if (data.content.length == 0) {
		jQuery("#com_medienarche_no_results").show();
		return;
	}
	jQuery("#com_medienarche_no_results").hide();
	
	for (var x=0;x<data.content.length; x++) {
		var html = '<div data-id="r'+x+'" data-obj="'+quoteattr(JSON.stringify(data.content[x]))+'" id="com_medienarche_result_r'+x+'" class="com_medienarche_result"><div class="com_medienarche_result_inner"><a href="#com_medienarche_modal_detail" class="modal" rel="{size: {x: 850, y: 400}}" onclick="com_medienarche_show_details(this)"><img src="'+data.content[x].variants[0].preview_images['200px']+'" /><h4 class="com_medienarche_result_title" title="'+data.content[x].title+'">'+data.content[x].title+'</h4></a><p class="com_medienarche_result_category">'+data.content[x].category+'</p></div></div>';
		jQuery("#com_medienarche_result_list").append(html);
	}
	
	
	
	SqueezeBox.assign(jQuery('a.modal').get(), {
		parse: 'rel'
	});	
	
}

function com_medienarche_search() {
	jQuery("#com_medienarche_result_list").hide();
	var categories = com_medienarche_all_categories.join("%2B");
	if (jQuery("#com_medienarche_filter_category").val()!="") {
		categories = jQuery("#com_medienarche_filter_category").val();
		jQuery("#com_medienarche_result_list").addClass("com_medienarche_result_list_hide_category");
	} else {
		jQuery("#com_medienarche_result_list").removeClass("com_medienarche_result_list_hide_category");
	}
	
	com_medienarche_api("find/"+categories+"/"+encodeURIComponent(jQuery("#com_medienarche_filter_text").val()), null, "com_medienarche_search_cb");
}

function com_medienarche_show_details(e) {
	var container = jQuery(e).parent().parent();
	jQuery(".com_medienarche_modal_detail_inner_image").show();
	jQuery(".com_medienarche_modal_detail_inner_checkout").hide();
	var data = JSON.parse(jQuery(container).attr("data-obj"));
	jQuery(".com_medienarche_detail_variants").hide();
	jQuery("#com_medienarche_modal_detail").attr("data-obj", jQuery(container).attr("data-obj"));
	jQuery(".com_medienarche_detail_variants").html("<h4>Variante wählen:</h4>");
	for (var i = 0; i <data.variants.length; i++) {
		jQuery(".com_medienarche_detail_variants").append('<a href="#" onclick="com_medienarche_show_details_variant('+i+');">'+ data.variants[i].variant_description +'</a><br/>');
		if (i >= 1) {
			jQuery(".com_medienarche_detail_variants").show();
		}
	}
	jQuery(".com_medienarche_modal_detail_img").parent().parent().parent().children("h3").html(data.title);
	jQuery(".com_medienarche_modal_detail_img").parent().parent().parent().children("p.com_medienarche_modal_detail_description").html(data.description);
	jQuery(".com_medienarche_modal_detail_img").parent().parent().parent().children("p.com_medienarche_modal_detail_description").attr("title", data.description);
	
	
	com_medienarche_show_details_variant(0);
	return true;
}


function com_medienarche_show_details_variant(variant) {
	var data = JSON.parse(jQuery('#com_medienarche_modal_detail').attr("data-obj"));
	com_medienarche_variant = data.variants[variant];
	jQuery(".com_medienarche_modal_detail_img").attr("src", com_medienarche_variant.preview_images['800px']);
	
	jQuery(".com_medienarche_detail_formats").html("");
	
	var formats = [];
	for (var i = 0; i < com_medienarche_variant.resolutions.length; i++) {
		if (formats.indexOf(com_medienarche_variant.resolutions[i].format) == -1) {
			jQuery(".com_medienarche_detail_formats").prepend('<option value="'+com_medienarche_variant.resolutions[i].format+'">'+com_medienarche_variant.resolutions[i].format+'</option>');
			formats.push(com_medienarche_variant.resolutions[i].format);
		}
	}
	com_medienarche_details_calc_size(false, true, "");
	return true;
}



function com_medienarche_details_calc_size(calcW, calcH, sBoxSlector) {
	if (com_medienarche_skip_size_calc) {
		return true;
	}
	if (sBoxSlector === undefined) {
		sBoxSlector = "#sbox-window ";
	}
	
	var format_str = jQuery(sBoxSlector+".com_medienarche_detail_formats").val();
	var format = format_str.split(":");
	com_medienarche_skip_size_calc = true;
	if (calcW == false && calcH == true) {
		jQuery(sBoxSlector+"[name='new_size_y']").val(Math.round(jQuery(sBoxSlector+"[name='new_size_x']").val() * format[1] / format[0]));
	} else if (calcW == true && calcH == false) {
		jQuery(sBoxSlector+"[name='new_size_x']").val(Math.round(jQuery(sBoxSlector+"[name='new_size_y']").val() / format[1] * format[0]));
	}
	com_medienarche_skip_size_calc = false;
	com_medienarche_download_id = 0;
	var tarSizeX = parseInt(jQuery(sBoxSlector+"[name='new_size_x']").val());
	var tarSizeY = parseInt(jQuery(sBoxSlector+"[name='new_size_y']").val());
	var curSizeX = 0;
	var curSizeY = 0;
	var maxSizeX = 0;
	var maxSizeY = 0;
	
	for (var i= 0; i<com_medienarche_variant.resolutions.length; i++) {
		if (com_medienarche_variant.resolutions[i].format == format_str) {
			var varPx = com_medienarche_variant.resolutions[i].px.split("x");
			varPx[0] = parseInt(varPx[0]);
			varPx[1] = parseInt(varPx[1]);
			if (tarSizeX <= varPx[0] && tarSizeY <= varPx[1] && (curSizeX == 0 || (curSizeX > varPx[0] && curSizeY > varPx[1]))) {
				curSizeX = varPx[0];
				curSizeY = varPx[1];
				com_medienarche_download_id = com_medienarche_variant.resolutions[i].download_id;
			}
			
			if (maxSizeX == 0 || maxSizeX < varPx[0]) {
				maxSizeX = varPx[0];
				maxSizeY = varPx[1];
			}
		}
	}
	if (com_medienarche_download_id == 0) {
		alert("Die eingegebene Größe ist für dieses Format nicht vorhanden. Die maximal verfügbare Größe beträgt " + maxSizeX + "x" + maxSizeY);
		if (maxSizeX != 0) {
			com_medienarche_skip_size_calc = true;
			jQuery(sBoxSlector+"[name='new_size_x']").val(maxSizeX);
			jQuery(sBoxSlector+"[name='new_size_y']").val(maxSizeY);
			com_medienarche_skip_size_calc = false;
			com_medienarche_details_calc_size(false, false);
		}
	}
}


function com_medienarche_folder_select (e) {
	
	jQuery(e).parent().children(".com_medienarche_detail_formats").val();
	
	jQuery(".com_medienarche_modal_detail_inner_image").hide();
	jQuery(".com_medienarche_modal_detail_inner_checkout").show();
	jQuery(".com_medienarche_modal_filename").val(com_medienarche_download_id+".jpg");
	com_medienarche_api("local_folders", null, "com_medienarche_get_folders_cb");
	return false;
}

function com_medienarche_download(data) {
	var error = false;
	jQuery("#sbox-window .com_medienarche_checkbox input").each(function(i) {
		if (jQuery(this).is(":checked") == false) {
			error = true;
			jQuery(this).parent().next().css("color", "#F00");
		} else {
			jQuery(this).parent().next().css("color", "");
		}
	});
	
	if (error) {
		alert("Bitte füllen Sie alle Pflichtfelder aus");
		return false;
	}
	
	
	var filename = jQuery("#sbox-window .com_medienarche_modal_filename").val();
	if (filename.substr(-4,4).toLowerCase() != ".jpg"){
		filename = filename + ".jpg";
		jQuery("#sbox-window .com_medienarche_modal_filename").val(filename);
	}
	
	com_medienarche_api("local_download&download_id="+com_medienarche_download_id+"&download_path="+com_medienarche_selected_path+"/"+filename+"&download_size_x="+jQuery("#sbox-window [name='new_size_x']").val()+"&download_size_y="+jQuery("#sbox-window [name='new_size_y']").val()+"&download_size_dpi="+jQuery("#sbox-window [name='new_size_dpi']").val(), null, "com_medienarche_download_cb");
	
}

function com_medienarche_download_cb(data) {
	alert("Das Bild wurde erfolgreich auf den Server kopiert.");
	if (com_medienarche_is_modal) {
		com_medienarche_modal_insert(data.content);
	} else {
		jModalClose();
	}
}
function quoteattr(s, preserveCR) {
    preserveCR = preserveCR ? '&#13;' : '\n';
    return ('' + s)
        .replace(/&/g, '&amp;')
        .replace(/'/g, '&apos;')
        .replace(/"/g, '&quot;')
        .replace(/</g, '&lt;')
        .replace(/>/g, '&gt;')
        .replace(/\r\n/g, preserveCR)
        .replace(/[\r\n]/g, preserveCR);
        ;
}

function com_medienarche_get_folders_cb(data) {
	var html = com_medienarche_get_folder_content_html(data.content);
	jQuery('#sbox-window .com_medienarche_tree_selector').jstree("destroy");
	jQuery('#sbox-window .com_medienarche_tree_selector').html(html);
	jQuery('#sbox-window .com_medienarche_tree_selector').jstree({
		"core": {
			multiple: false
		}
	});
	if (com_medienarche_selected_path != "") {
		com_medienarche_folders_open_node(com_medienarche_selected_path);
	} else {
		com_medienarche_folders_open_node("images/");
	}
	
	jQuery('#sbox-window .com_medienarche_tree_selector').on('changed.jstree', function (e, data) {
		var i, j = [];
		for(i = 0, j = data.selected.length; i < j; i++) {
		  com_medienarche_selected_path = jQuery("#"+data.selected[i]).attr("data-path");
		}
	});
}

function com_medienarche_get_folder_content_html(data) {
	var html = "<ul>";
	for (var i=0; i < data.length; i++) {
		html += '<li data-path="'+data[i].path+'">' + data[i].text;
		if (data[i].children.length > 0) {
			html += com_medienarche_get_folder_content_html(data[i].children);
		}
	}
	html += "</ul>";
	return html;
}
function com_medienarche_folders_open_node(path) {
	var folders = path.split("/");
	var build_path = "";
	for (var i=0;i<folders.length;i++) {
		build_path += folders[i];
		if (folders[i] == "") {
			continue;
		}
		jQuery("#sbox-window .com_medienarche_tree_selector").jstree("open_node",jQuery("[data-path='"+build_path+"']"));
		jQuery("#sbox-window .com_medienarche_tree_selector").jstree("activate_node",jQuery("[data-path='"+build_path+"']"));
		
		build_path += "\/";
	}
}
function com_medienarche_new_folder() {
	com_medienarche_selected_path = com_medienarche_selected_path + "/" + jQuery("#sbox-window .com_medienarche_modal_new_folder").val();
	com_medienarche_api("local_new_folder&new_folder="+com_medienarche_selected_path, null, "com_medienarche_new_folder_cb");
}
function com_medienarche_new_folder_cb() {
	com_medienarche_api("local_folders", null, "com_medienarche_get_folders_cb");
}

function com_medienarche_modal_insert (path) {
	var tag = '<img src="' + path + '" ' + com_medienarche_modal_imgAttributes + ' />';
	/** Use the API, if editor supports it **/
	if (window.parent.Joomla && window.parent.Joomla.editors && window.parent.Joomla.editors.instances && window.parent.Joomla.editors.instances.hasOwnProperty(com_medienarche_modal_editor)) {
		window.parent.Joomla.editors.instances[com_medienarche_modal_editor].replaceSelection(tag)
	} else {
		window.parent.jInsertEditorText(tag, com_medienarche_modal_editor);
	}

	window.parent.jModalClose();
};
