<?php
/**
 * @package     com_medienarche
  *
 * @copyright   Copyright (C) AK Internet und Medienarche
 */

defined('_JEXEC') or die;
JHtml::_('behavior.core');
$app = JFactory::getApplication();
$jinput = $app->input;
$comParams = JComponentHelper::getParams( 'com_medienarche' );
$convertType = false;
if (class_exists("Imagick")) {
	$convertType = "class";
} else {
	$command = $comParams->get("imagick_convert_command", "convert");
	$output = array();
	exec ($command." -version", $output);
	if (count($output) != 0) {
		if ($output[0] != str_replace("ImageMagick", "", $output[0])) {
			$convertType = "command";
		}
	}
}

if (!$convertType) {
	$app->enqueueMessage(JText::_("COM_MEDIENARCHE_ERROR_IMAGICK"), "error");
	$app->redirect("index.php");
}

if ($jinput->get("api") == "1") {
	header("Content-Type: application/json");
	//Lokale API
	//API Key speichern
	
	if ($jinput->get("path") =="local_store_apikey") {
		$componentid = JComponentHelper::getComponent('com_medienarche')->id;
		$table = JTable::getInstance('extension');
		$table->load($componentid);
		$comParams->set("apikey", $jinput->get("apikey"));
		$table->bind(array('params' => $comParams->toString()));
		// check for error
		if (!$table->check()) {
			echo $table->getError();
			return false;
		}
		// Save to database
		if (!$table->store()) {
			echo $table->getError();
			return false;
		}
		echo '{"error":{"code":0,"description":"No error"},"content":"success"}';
		
		//Medien-Download
	} else if ($jinput->get("path") =="local_new_folder") {
		if (mkdir(JPATH_SITE."/".$jinput->get("new_folder", "", "RAW"))) {
			echo '{"error":{"code":0,"description":"No error"},"content":"'.JPATH_SITE."/".$jinput->get("new_folder", "", "RAW").'"}';
		} else {
			echo '{"error":{"code":-1,"description":"Could not created folder"},"content":"'.JPATH_SITE."/".$jinput->get("new_folder", "", "RAW").'"}';	
		}
		
	} else if ($jinput->get("path") =="local_download") {
		$header = getallheaders();
		$new_headers = Array("Authorization: " . $headers["X-Aki-Ma-Authorization"]);
		
		$curl_handle=curl_init();
		curl_setopt($curl_handle,CURLOPT_URL, "https://www.medienarche.de/api/download/".$jinput->get("download_id"));
		curl_setopt($curl_handle,CURLOPT_CONNECTTIMEOUT,2);
		curl_setopt($curl_handle,CURLOPT_RETURNTRANSFER,1);
		curl_setopt($curl_handle,CURLOPT_FOLLOWLOCATION,true);
		curl_setopt($curl_handle, CURLOPT_HTTPHEADER, $new_headers);
		$buffer = curl_exec($curl_handle);
		curl_close($curl_handle);
		if (empty($buffer)){
		  print '{"error":{"code":-1,"description":"no server response"}, "content":""}';
		}
		$obj = json_decode($buffer);
		if ($obj->error->code != 0) {
			print $buffer;
			exit;
		}
		
		$url = $jinput->get("download_path", "images/medienarche", "RAW");
		$path = JPATH_SITE."/".$url;
		if (file_exists($path)) {
			echo '{"error":{"code":-2,"description":"File already exists"},"content":""}';
			exit;
		}
		$ifp = fopen( $path, 'wb' ); 
		$data = explode( ',', $obj->content->base64 );
		fwrite( $ifp, base64_decode( $data[ 1 ] ) );
		fclose( $ifp );
		
		
		
		$new_width = $jinput->get("download_size_x", 0);
		$new_height = $jinput->get("download_size_y", 0);
		$new_dpi = $jinput->get("download_size_dpi", 72);
		
		switch ($convertType) {
			case "class":
				$img = new Imagick($path);
				if ($img) {
					$img->setImageResolution($new_dpi,$new_dpi); 
					$img->resampleImage ($new_dpi,$new_dpi,0,1);
					$img->resizeImage ($new_width,$new_height,0,1);
					$img->writeImage($path);
				} else {
				  echo '{"error":{"code":-3,"description":"Unknown image format"},"content":""}';
				  exit;
				}
				break;
			
			case "command":
				$command = 'convert "'.$path.'" -resize "'.$new_width.'x'.$new_height.'" -density '.$new_dpi.' -units PixelsPerInch "'.$path.'"';
				exec($command);
				break;
				
			default:
				echo '{"error":{"code":-3,"description":"Could not convert image"},"content":""}';
		}
		
		echo '{"error":{"code":0,"description":"No error"},"content":"'.$url.'"}';
		
	} else if ($jinput->get("path") =="local_folders") {
				function com_medienarche_get_folders_recursive ($dir) {
					$basedir = JPATH_SITE."/";
					$skip = Array(".", "..");
					$return = Array();
					$content = scandir($basedir.$dir);
					foreach ($content as $itm) {
						if (in_array($itm, $skip) || !is_dir($basedir.$dir.$itm)) {
							continue;
						}
						$folder = new stdClass;
						$folder->path=$dir.$itm;
						$folder->text=$itm;
						$folder->children=com_medienarche_get_folders_recursive($dir.$itm."/");
						$return[]  = $folder;
					}
					return $return;
				}
		
		$folder = new stdClass;
		$folder->path="images";
		$folder->text="images";
		$folder->children = com_medienarche_get_folders_recursive("images/");
		echo '{"error":{"code":0,"description":"No error"},"content":'.json_encode(Array($folder)).'}';
		exit;
	} else {
		
		
		
		
		//API zur Medienarche
		$headers = getallheaders();
		$new_headers = Array("Authorization: " . $headers["X-Aki-Ma-Authorization"]);
		
		$curl_handle=curl_init();
		curl_setopt($curl_handle,CURLOPT_URL, "https://www.medienarche.de/api/".$_GET["path"]);
		curl_setopt($curl_handle,CURLOPT_CONNECTTIMEOUT,2);
		curl_setopt($curl_handle,CURLOPT_RETURNTRANSFER,1);
		curl_setopt($curl_handle,CURLOPT_FOLLOWLOCATION,true);
		curl_setopt($curl_handle, CURLOPT_HTTPHEADER, $new_headers);
		$buffer = curl_exec($curl_handle);
		curl_close($curl_handle);
		if (empty($buffer)){
		  print '{"error":{"code":-1,"description":"no server response"}, "content":""}';
		} else{
		  print $buffer;
		}
	}
	exit;
}


$doc = JFactory::getDocument();
$doc->addStyleSheet(JURI::root(true)."/components/com_medienarche/assets/css/com_medienarche.css");
$doc->addStyleSheet(JURI::root(true)."/components/com_medienarche/assets/js/jstree/src/themes/default/style.css");


JHtml::_('jquery.framework');
	JHtml::_('behavior.modal');



$script = "var com_medienarche_apikey = '".$comParams->get("apikey", "")."'\n";
if ($jinput->get("layout", "") == "modal") {
	$script .= "var com_medienarche_is_modal = true;\nvar com_medienarche_modal_editor = '".$jinput->get("editor", "")."';\nvar com_medienarche_modal_imgAttributes = '".$comParams->get("imgAttributes", 'style="width: 300px; margin: 0px 5px;"')."'";
} else {
	$script .= "var com_medienarche_is_modal = false;";
}
$doc->addScriptDeclaration($script);
$doc->addScript(JURI::root(true)."/components/com_medienarche/assets/js/com_medienarche.js");
$doc->addScript(JURI::root(true)."/components/com_medienarche/assets/js/jstree/src/jstree.js");
$extended_mode  = $comParams->get("extended_mode", 0);

?>



<div id="com_medienarche_main">
	<div id="com_medienarche_loader" style="">
		
	</div>
	<div id="com_medienarche_results" style="display: none;">
			<div class="js-stools-container-bar">
					<div class="btn-wrapper input-append">
						<input name="com_medienarche_filter_text" id="com_medienarche_filter_text" value="" placeholder="Suche" data-original-title="" title="" type="text" />
						<button type="submit" class="btn hasTooltip" title="" aria-label="Suchen" data-original-title="Suchen" id="com_medienarche_filter_do">
							<span class="icon-search" aria-hidden="true"></span>
						</button>
					</div>
					<div class="btn-wrapper input-append">
						<select id="com_medienarche_filter_category" name="filter_category" class="selectpicker">
							<option value="" selected="selected">- Kategorie wählen -</option>
						</select>
					</div>
			</div>
			<div id="com_medienarche_result_list"></div>
			<div id="com_medienarche_no_results" style="display: none;">
				<h3>Es wurden keine Einträge gefunden</h3>
			</div>
	</div>
	
	<div style="display: none"><!--;-->
		<div id="com_medienarche_modal_detail" style="">
			<div class="com_medienarche_modal_detail_inner">
				<h3>Title</h3>
				<p class="com_medienarche_modal_detail_description"></p>
				<div class="com_medienarche_modal_detail_inner_image">
					<div style="float: left; width: 70%">
						<img class="com_medienarche_modal_detail_img" src="https://www.medienarche.de/livesite/wp-content/uploads/Hintergrund_var1_berggrat-bei-sonnenaufgang_WZ-gr-800x450.jpg" style="width: 95%"/>
					</div>
					<div style="float: left; width: 30%">
						
						<div class="com_medienarche_detail_variants"></div>
						<h4>Format wählen:</h4>
						<select onchange="com_medienarche_details_calc_size(false, true);" class="com_medienarche_detail_formats">
						</select>
						
						<h4>Ziel-Größe:</h4>
						<input name="new_size_x" onchange="com_medienarche_details_calc_size(false, true);" type="text" placeholder="Breite" class="com_medienarche_detail_new_size" value="<?php echo $comParams->get("default_img_width", "450"); ?>"/> X 
						<input name="new_size_y" onchange="com_medienarche_details_calc_size(true, false);" type="text" placeholder="Höhe" class="com_medienarche_detail_new_size"/>
						
						
						<h4 style="<?php echo ($extended_mode)? "" : "display: none;"; ?>">Ziel-Auflösung:</h4>
						<select class="com_medienarche_detail_new_dpi" style="<?php echo ($extended_mode)? "" : "display: none;"; ?>" name="new_size_dpi">
							<option value="72">72 dpi</option>
							<option value="96">96 dpi</option>
							<option value="144">144 dpi</option>
						</select>
						<a href="#" onclick="com_medienarche_folder_select(this); return false;" class="btn btn-primary">Weiter</a>
					</div>
				</div>
				<div class="com_medienarche_modal_detail_inner_checkout" style="display: none;">
					<div class="com_medienarche_modal_detail_inner_checkout_col1">
						<h4>Speicherort auswählen</h4>
						<div class="com_medienarche_tree_selector"></div>
					</div>
					<div class="com_medienarche_modal_detail_inner_checkout_col2">
						<h4>Neuen Ordner erstellen</h4>
						<p>Bitte wähle links einen Ordner und gebe hier einen Namen ein, um einen neuen Unterordner zu erstellen</p>
						<input type="text" placeholder="Name des Ordners" class="com_medienarche_modal_new_folder"/>
						<a href="#" onclick="com_medienarche_new_folder(); return false;" class="btn btn-primary">Ordner anlegen</a>
					</div>
					<div class="com_medienarche_modal_detail_inner_checkout_col3">
						<h4>Dateiname</h4>
						<p>Bitte gib einen Dateinamen ein:</p>
						<input type="text" placeholder="Dateiname" class="com_medienarche_modal_filename"/>
						<p></p>
						<div class="com_medienarche_checkbox">
							<input type="checkbox"/>
						</div>
						<div class="com_medienarche_checkbox_label">
							<p>Mir sind die <a href="https://www.medienarche.de/faq/" target="_BLANK">Lizenzbedingungen</a> der Medienarche bekannt.*</p>
						</div>
						
						<div class="com_medienarche_checkbox">
							<input type="checkbox"/>
						</div>
						<div class="com_medienarche_checkbox_label">
							<p>Ich weiß, wie ich die Medienarche <a href="https://www.medienarche.de/unterstuetzen/" target="_BLANK">unterstützen</a> kann. *</p>
						</div>
						
						<a href="#" onclick="com_medienarche_download(); return false;" class="btn btn-primary" style="text-align: right">Herunterladen</a>
					</div>
				</div>
			</div>
		</div>
	</div>

	<div id="com_medienarche_authentification" style="display: none;">
		<div id="com_medienarche_authentification_container">
			<h3>Herzlich wilkommen...</h3>
			<p>...bei der Medienarche. Für diesen Service benötigst Du ein kostenloses Benutzerkonto bei der Medienarche. Bitte gib Deine Zugangsdaten hier ein:</p>
			
			<fieldset class="loginform">
				<div class="control-group">
					<div class="controls">
						<div class="input-prepend" style="margin: 0px auto;">
							<span class="add-on">
								<span class="icon-user hasTooltip" title="" data-original-title="Benutzername"></span>
								<label for="com_medienarche_username" class="element-invisible">
									Benutzername						</label>
							</span>
							<input name="username" tabindex="1" id="com_medienarche_username" class="input-medium" placeholder="Benutzername" size="15" autofocus="true"  type="text">
							
						</div>
					</div>
				</div>
				<div class="control-group">
					<div class="controls">
						<div class="input-prepend" style="margin: 0px auto;">
							<span class="add-on">
								<span class="icon-lock hasTooltip" title="" data-original-title="Passwort"></span>
								<label for="com_medienarche_password" class="element-invisible">
									Passwort						</label>
							</span>
							<input name="passwd" tabindex="2" id="com_medienarche_password" class="input-medium" placeholder="Passwort" size="15" type="password">
							
						</div>
					</div>
				</div>
			<p><a href="https://www.medienarche.de/my-account/lost-password/" target="_BLANK" class="">Passwort vergessen?</a></p>
						
				<div class="control-group">
					<div class="controls">
						<div class="btn-group">
							<button tabindex="5" class="btn btn-primary" id="com_medienarche_authentification_submit">
								<span class="icon-lock icon-white"></span>Anmelden</button>
						</div>
					</div>
				</div>
			</fieldset>
			
			
			<p>Du besitzt noch kein Benutzerkonto? <a href="https://www.medienarche.de/my-account/?action=register" target="_BLANK" class="">Lege hier ein Konto an</a></p>
		</div>
	</div>
</div>